# ape を読み込む
library(ape)

# インファイル名を変数に格納する
inFile.name <- ("tree_BS.tre")
outGroup <- "AJ534546"

# tree をインファイルから読み込む
MyTree <- read.tree(inFile.name)
MyTree <- root(MyTree, outGroup, r=T)


# 系統樹を書いたときに，上にルートが来るようにする
MyTree <- ladderize(MyTree)
# 系統樹を書いたときに，下にルートが来るようにする
#MyTree <- ladderize(MyTree,FALSE)

# newick tree を　nexus 形式で保存する．
write.tree(MyTree, file="tree_BS_reordered.tre")  # Phylip 形式．
#write.nexus(MyTree, file="MyNexusTreefile.nex")   # Nexus 形式

# プリントアウトに必要なデバイスを用意する．
image.file <- paste(inFile.name, ".pdf", sep = "") 
pdf(image.file) 

# Tree をプロットする．
plot(MyTree)
add.scale.bar()
nodelabels(MyTree$node.label, adj = c(1.2,-0.5), frame = "n")

# dev.off という関数でデバイスを閉じます．
dev.off()
