#!/usr/bin/env python

import re
from collections import OrderedDict

def readFasta_dict(InfileNameFN):
    Infile = open(InfileNameFN, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line
    Infile.close()
    return seqDictFN

def get_leaves(tree_fn):
    #print(tree_fn)
    #print()
    #### Delete branch lengths
    tree_fn = tree_fn.rstrip("\n")
    tree_fn = re.sub(":-", ":", tree_fn)
    tree_fn = re.sub("e-\d+\)", ")", tree_fn)
    tree_fn = re.sub("e-\d+,", ",", tree_fn)
    tree_fn = re.sub(":[\d\.]+\)", ")", tree_fn)
    tree_fn = re.sub(":[\d\.]+,", ",", tree_fn)
    #print(tree_fn)
    #print()
    #### Delete BS values
    tree_fn = re.sub("\)\d+\)", "))", tree_fn)
    tree_fn = re.sub("\)\d+\)", "))", tree_fn)
    tree_fn = re.sub("\)\d+,", "),", tree_fn)
    tree_fn = re.sub("\)\d+;", ");", tree_fn)
    #print(tree_fn)
    #exit()
    #### Delete comman and parenthass
    tree_fn = re.sub("[\)\(]+", ",", tree_fn)
    tree_fn = re.sub(",+", ",", tree_fn)
    tree_fn = re.sub("^,", "", tree_fn)
    #print(tree_fn)
    #print()
    tree_fn = re.sub(",Root;", "", tree_fn)
    tree_fn = re.sub(",;", "", tree_fn)
    #print(tree_fn)
    #exit()
    leaves_list = tree_fn.split(",")

    #print(leaves_list)
    #leaves_list.reverse()    
    #print(leaves_list)
    #exit()
    return leaves_list

def sort_by_tree(leaves_fn, seqDict_seqfile):
    seqDict_reordered_fn  = OrderedDict()
    for leaf in leaves_fn:
        seqDict_reordered_fn[">" + leaf] = seqDict_seqfile[">" + leaf]
    return(seqDict_reordered_fn)

######
InfileName_seq = "infile_fasta.txt"
seqDict = readFasta_dict(InfileName_seq)
OutfileName_seq = "out_fasta.txt"

InfileName_tree = "tree_BS_reordered.tre"
treeTMP = open(InfileName_tree)
tree = list(treeTMP)[0]
treeTMP.close()

leaves = get_leaves(tree)

if len(seqDict) == len(leaves):
    seqDict_reordered = sort_by_tree(leaves, seqDict)
else:
   print("Different leaves between", InfileName_seq, InfileName_tree)

out = open(OutfileName_seq, "w")
for name, seq in seqDict_reordered.items():
    out.write(name + "\n")
    out.write(seq + "\n")
out.close()
